public class Base64Encoder {

	private static String encoded=
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	/* Returns the number of bytes output after encoding. 
	The length is always a multiple of 4. */
	public int encodeBytes(byte in[], int inputlen, byte out[]) {
		int outputlen=0;
		int inp=0;
		int ntimes=inputlen/3;
		int nleft=inputlen%3;
		for(int i=0;i<ntimes;++i) {
			out[outputlen]  =(byte)encoded.charAt((in[inp]&0xfc)>>>2);	
			out[outputlen+1]=(byte)encoded.charAt(((in[inp]&0x03)<<4)+((in[inp+1]&0xf0)>>>4));	
			out[outputlen+2]=(byte)encoded.charAt(((in[inp+1]&0x0f)<<2)+((in[inp+2]&0xc0)>>>6));	
			out[outputlen+3]=(byte)encoded.charAt((in[inp+2]&0x3f));	
			inp+=3; outputlen+=4; 
		}
		if(nleft>0) {
			out[outputlen]  =(byte)encoded.charAt((in[inp]&0xfc)>>>2);	
			out[outputlen+1]=(byte)encoded.charAt(((in[inp]&0x03)<<4));	
			out[outputlen+2]=(byte)'='; //Override if one more left.
			out[outputlen+3]=(byte)'=';
			if(nleft>1) {
				out[outputlen+2]=(byte)encoded.charAt(((in[inp+1]&0x0f)<<2));	
			}
			inp+=nleft; outputlen+=4;
		}
		return outputlen;
	}
}
